/*
 * Copyright 2007-2016 University of New Hampshire Interoperability Laboratory
 * All rights reserved.
 *
 * This file is part of the UNH EXS implementation of the
 * Consortium Specification: Extended Sockets API (ES-API) Issue 1.0,
 * Document Number C050 published by The Open Group, January 2005,
 * and copyright 2005 by The Open Group.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING.GPL in the main directory of this source tree, or the
 * BSD license, available from the file COPYING.BSD in the main directory
 * of this source tree.
 *
 * This material is based upon work supported by the National Science
 * Foundation under Grants No. OCI-1127228 and DGE-0913620.
 *
 * Any opinions, findings, and conclusions or recommendations
 * expressed in this material are those of the authors and do not
 * necessarily reflect the views of the National Science Foundation.
 */

#ifndef _EXS_WRITE_SETUP_H
#define _EXS_WRITE_SETUP_H

#include "../result.h"

#define WRITE_TESTS 11

static char *all_write_tests[WRITE_TESTS] = {
	"1  : EPERM                   : exs_write(fd, send_buf, SEND_BUFSIZE) [no exs_init]",
	"2  : ENOTCONN                : exs_write(NOT_CONNECTED_FD, send_buf, SEND_BUFSIZE)",
	"3  : EINVAL                  : exs_write(fd, NULL_BUFFER, SEND_BUFSIZE)",
	"",
	"5  : EPIPE                   : exs_write(fd, send_buf, SEND_BUFSIZE) [gracefull shut down for writing]",
	"",
	"",
	"",
	"",
	"",
	"11 : OK_EXS_WRITE            : exs_write(fd, send_buf, SEND_BUFSIZE)"
};

static int list_write_tests(int select)
{
	if (select < 0 || select > WRITE_TESTS) {
		fprintf(stdout, "Invalid -t test number (1 - %d)\n",
			WRITE_TESTS);
		exit(0);
	}

	if (select == 0) {
		int i;
		for (i = 0; i < WRITE_TESTS; i++) {
			if (strcmp(all_write_tests[i], "") != 0)
				fprintf(stdout, "%s\n",
					all_write_tests[i]);
		}
	} else {
		fprintf(stdout, "%s\n", all_write_tests[select - 1]);
	}

	exit(0);
}

static int ok_exs_write(param * p)
{
	char *name = "ok_exs_write";

	int ret = exs_write(p->fd, p->send_buf, p->SEND_BUFSIZE);

	if (ret < p->SEND_BUFSIZE) {
		print_error(name);
		return -1;
	}
	return ret;

}

#endif
