#!/bin/sh
# test_all_check.sh
# Run all tests and return non-zero if tests fail

# Copyright 2016 University of New Hampshire Interoperability Laboratory
# All rights reserved.
#
# This file is part of the UNH EXS implementation of the
# Consortium Specification: Extended Sockets API (ES-API) Issue 1.0,
# Document Number C050 published by The Open Group, January 2005,
# and copyright 2005 by The Open Group.
#
# This software is available to you under a choice of one of two
# licenses.  You may choose to be licensed under the terms of the GNU
# General Public License (GPL) Version 2, available from the file
# COPYING.GPL in the main directory of this source tree, or the
# BSD license, available from the file COPYING.BSD in the main directory
# of this source tree.
#
# This material is based upon work supported by the National Science
# Foundation under Grants No. OCI-1127228 and DGE-0913620.
#
# Any opinions, findings, and conclusions or recommendations
# expressed in this material are those of the authors and do not
# necessarily reflect the views of the National Science Foundation.

EXIT_SUCCESS=0
EXIT_FAILURE=1
EXIT_SKIP=77
EXIT_ERROR=99

if type ibv_devinfo 2>/dev/null && ibv_devinfo >/dev/null 2>&1; then :; else
	printf "No RDMA hardware devices found; test suite not run\n"
	exit ${EXIT_SKIP}
fi

if ${srcdir}/tests/test_all.sh | grep "FAIL"; then
	exit ${EXIT_FAILURE}
else
	exit ${EXIT_SUCCESS}
fi
